Index: uspace/lib/c/generic/io/con_srv.c
===================================================================
--- uspace/lib/c/generic/io/con_srv.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/con_srv.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 #include <io/con_srv.h>
 
-static errno_t console_ev_encode(cons_event_t *event, ipc_call_t *call)
+static int console_ev_encode(cons_event_t *event, ipc_call_t *call)
 {
 	IPC_SET_ARG1(*call, event->type);
@@ -71,5 +71,5 @@
 	void *buf;
 	size_t size;
-	errno_t rc;
+	int rc;
 	ipc_callid_t rcallid;
 
@@ -93,7 +93,6 @@
 	}
 
-	size_t nread;
-	rc = srv->srvs->ops->read(srv, buf, size, &nread);
-	if (rc != EOK) {
+	rc = srv->srvs->ops->read(srv, buf, size);
+	if (rc < 0) {
 		async_answer_0(rcallid, rc);
 		async_answer_0(callid, rc);
@@ -102,8 +101,11 @@
 	}
 
-	async_data_read_finalize(rcallid, buf, nread);
+	async_data_read_finalize(rcallid, buf, size);
 	free(buf);
 
-	async_answer_1(callid, EOK, nread);
+	if (rc >= 0)
+		async_answer_1(callid, EOK, rc);
+	else
+		async_answer_0(callid, rc);
 }
 
@@ -113,5 +115,5 @@
 	void *data;
 	size_t size;
-	errno_t rc;
+	int rc;
 
 	rc = async_data_write_accept(&data, false, 0, 0, 0, &size);
@@ -126,9 +128,11 @@
 	}
 
-	size_t nwritten = 0;
-	rc = srv->srvs->ops->write(srv, data, size, &nwritten);
+	rc = srv->srvs->ops->write(srv, data, size);
 	free(data);
 
-	async_answer_1(callid, rc, nwritten);
+	if (rc >= 0)
+		async_answer_1(callid, EOK, rc);
+	else
+		async_answer_0(callid, rc);
 }
 
@@ -178,5 +182,5 @@
     ipc_call_t *call)
 {
-	errno_t rc;
+	int rc;
 	sysarg_t col;
 	sysarg_t row;
@@ -194,5 +198,5 @@
     ipc_call_t *call)
 {
-	errno_t rc;
+	int rc;
 	sysarg_t cols;
 	sysarg_t rows;
@@ -210,5 +214,5 @@
     ipc_call_t *call)
 {
-	errno_t rc;
+	int rc;
 	console_caps_t ccap;
 
@@ -295,5 +299,5 @@
     ipc_call_t *call)
 {
-	errno_t rc;
+	int rc;
 	cons_event_t event;
 	ipc_call_t result;
@@ -340,8 +344,8 @@
 }
 
-errno_t con_conn(ipc_callid_t iid, ipc_call_t *icall, con_srvs_t *srvs)
+int con_conn(ipc_callid_t iid, ipc_call_t *icall, con_srvs_t *srvs)
 {
 	con_srv_t *srv;
-	errno_t rc;
+	int rc;
 
 	/* Accept the connection */
Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/console.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -90,8 +90,8 @@
 }
 
-errno_t console_get_size(console_ctrl_t *ctrl, sysarg_t *cols, sysarg_t *rows)
-{
-	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
-	errno_t rc = async_req_0_2(exch, CONSOLE_GET_SIZE, cols, rows);
+int console_get_size(console_ctrl_t *ctrl, sysarg_t *cols, sysarg_t *rows)
+{
+	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
+	int rc = async_req_0_2(exch, CONSOLE_GET_SIZE, cols, rows);
 	async_exchange_end(exch);
 	
@@ -129,8 +129,8 @@
 }
 
-errno_t console_get_color_cap(console_ctrl_t *ctrl, sysarg_t *ccap)
-{
-	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
-	errno_t rc = async_req_0_1(exch, CONSOLE_GET_COLOR_CAP, ccap);
+int console_get_color_cap(console_ctrl_t *ctrl, sysarg_t *ccap)
+{
+	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
+	int rc = async_req_0_1(exch, CONSOLE_GET_COLOR_CAP, ccap);
 	async_exchange_end(exch);
 	
@@ -138,8 +138,8 @@
 }
 
-errno_t console_get_pos(console_ctrl_t *ctrl, sysarg_t *col, sysarg_t *row)
-{
-	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
-	errno_t rc = async_req_0_2(exch, CONSOLE_GET_POS, col, row);
+int console_get_pos(console_ctrl_t *ctrl, sysarg_t *col, sysarg_t *row)
+{
+	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
+	int rc = async_req_0_2(exch, CONSOLE_GET_POS, col, row);
 	async_exchange_end(exch);
 	
@@ -154,5 +154,5 @@
 }
 
-static errno_t console_ev_decode(ipc_call_t *call, cons_event_t *event)
+static int console_ev_decode(ipc_call_t *call, cons_event_t *event)
 {
 	event->type = IPC_GET_ARG1(*call);
@@ -188,5 +188,5 @@
 		async_exchange_end(exch);
 		
-		errno_t rc;
+		sysarg_t rc;
 		async_wait_for(aid, &rc);
 		
@@ -202,5 +202,5 @@
 		}
 	} else {
-		errno_t retval;
+		sysarg_t retval;
 		async_wait_for(ctrl->input_aid, &retval);
 		
@@ -208,9 +208,9 @@
 		
 		if (retval != EOK) {
-			errno = retval;
-			return false;
-		}
-		
-		errno_t rc = console_ev_decode(&ctrl->input_call, event);
+			errno = (int) retval;
+			return false;
+		}
+		
+		int rc = console_ev_decode(&ctrl->input_call, event);
 		if (rc != EOK) {
 			errno = rc;
@@ -235,6 +235,6 @@
 	}
 	
-	errno_t retval;
-	errno_t rc = async_wait_timeout(ctrl->input_aid, &retval, *timeout);
+	sysarg_t retval;
+	int rc = async_wait_timeout(ctrl->input_aid, &retval, *timeout);
 	if (rc != EOK) {
 		*timeout = 0;
@@ -246,5 +246,5 @@
 	
 	if (retval != EOK) {
-		errno = retval;
+		errno = (int) retval;
 		return false;
 	}
Index: uspace/lib/c/generic/io/input.c
===================================================================
--- uspace/lib/c/generic/io/input.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/input.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,5 @@
 static void input_cb_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg);
 
-errno_t input_open(async_sess_t *sess, input_ev_ops_t *ev_ops,
+int input_open(async_sess_t *sess, input_ev_ops_t *ev_ops,
     void *arg, input_t **rinput)
 {
@@ -59,5 +59,5 @@
 
 	port_id_t port;
-	errno_t rc = async_create_callback_port(exch, INTERFACE_INPUT_CB, 0, 0,
+	int rc = async_create_callback_port(exch, INTERFACE_INPUT_CB, 0, 0,
 	    input_cb_conn, input, &port);
 	
@@ -83,8 +83,8 @@
 }
 
-errno_t input_activate(input_t *input)
+int input_activate(input_t *input)
 {
 	async_exch_t *exch = async_exchange_begin(input->sess);
-	errno_t rc = async_req_0_0(exch, INPUT_ACTIVATE);
+	int rc = async_req_0_0(exch, INPUT_ACTIVATE);
 	async_exchange_end(exch);
 	
@@ -95,5 +95,5 @@
     ipc_call_t *call)
 {
-	errno_t rc = input->ev_ops->active(input);
+	int rc = input->ev_ops->active(input);
 	async_answer_0(callid, rc);
 }
@@ -102,5 +102,5 @@
     ipc_call_t *call)
 {
-	errno_t rc = input->ev_ops->deactive(input);
+	int rc = input->ev_ops->deactive(input);
 	async_answer_0(callid, rc);
 }
@@ -113,5 +113,5 @@
 	keymod_t mods;
 	wchar_t c;
-	errno_t rc;
+	int rc;
 
 	type = IPC_GET_ARG1(*call);
@@ -129,5 +129,5 @@
 	int dx;
 	int dy;
-	errno_t rc;
+	int rc;
 
 	dx = IPC_GET_ARG1(*call);
@@ -145,5 +145,5 @@
 	unsigned max_x;
 	unsigned max_y;
-	errno_t rc;
+	int rc;
 
 	x = IPC_GET_ARG1(*call);
@@ -161,5 +161,5 @@
 	int bnum;
 	int press;
-	errno_t rc;
+	int rc;
 
 	bnum = IPC_GET_ARG1(*call);
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/io.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -108,8 +108,8 @@
 	 * This will probably be removed later.
 	 */
+	 
 	int infd = inbox_get("stdin");
 	if (infd >= 0) {
-		int stdinfd = -1;
-		(void) vfs_clone(infd, -1, false, &stdinfd);
+		int stdinfd = vfs_clone(infd, -1, false);
 		assert(stdinfd == 0);
 		vfs_open(stdinfd, MODE_READ);
@@ -122,9 +122,8 @@
 	int outfd = inbox_get("stdout");
 	if (outfd >= 0) {
-		int stdoutfd = -1;
-		(void) vfs_clone(outfd, -1, false, &stdoutfd);
+		int stdoutfd = vfs_clone(outfd, -1, false);
 		assert(stdoutfd <= 1);
 		while (stdoutfd < 1)
-			(void) vfs_clone(outfd, -1, false, &stdoutfd);
+			stdoutfd = vfs_clone(outfd, -1, false);
 		vfs_open(stdoutfd, MODE_APPEND);
 		stdout = fdopen(stdoutfd, "a");
@@ -136,9 +135,8 @@
 	int errfd = inbox_get("stderr");
 	if (errfd >= 0) {
-		int stderrfd = -1;
-		(void) vfs_clone(errfd, -1, false, &stderrfd);
+		int stderrfd = vfs_clone(errfd, -1, false);
 		assert(stderrfd <= 2);
 		while (stderrfd < 2)
-			(void) vfs_clone(errfd, -1, false, &stderrfd);
+			stderrfd = vfs_clone(errfd, -1, false);
 		vfs_open(stderrfd, MODE_APPEND);
 		stderr = fdopen(stderrfd, "a");
@@ -296,13 +294,12 @@
 	if (create)
 		flags |= WALK_MAY_CREATE;
-	int file;
-	errno_t rc = vfs_lookup(path, flags, &file);
-	if (rc != EOK) {
-		errno = rc;
+	int file = vfs_lookup(path, flags);
+	if (file < 0) {
+		errno = file;
 		free(stream);
 		return NULL;
 	}
 
-	rc = vfs_open(file, mode);
+	int rc = vfs_open(file, mode);
 	if (rc != EOK) {
 		errno = rc;
@@ -364,5 +361,5 @@
 static int _fclose_nofree(FILE *stream)
 {
-	errno_t rc = 0;
+	int rc = 0;
 	
 	fflush(stream);
@@ -376,6 +373,6 @@
 	list_remove(&stream->link);
 	
-	if (rc != EOK) {
-		errno = rc;
+	if (rc != 0) {
+		/* errno was set by close() */
 		return EOF;
 	}
@@ -433,5 +430,5 @@
 static size_t _fread(void *buf, size_t size, size_t nmemb, FILE *stream)
 {
-	errno_t rc;
+	int rc;
 	size_t nread;
 
@@ -462,5 +459,5 @@
 static size_t _fwrite(const void *buf, size_t size, size_t nmemb, FILE *stream)
 {
-	errno_t rc;
+	int rc;
 	size_t nwritten;
 
@@ -495,5 +492,5 @@
 static void _ffillbuf(FILE *stream)
 {
-	errno_t rc;
+	int rc;
 	size_t nread;
 
@@ -799,7 +796,7 @@
 }
 
-int fseek64(FILE *stream, off64_t offset, int whence)
-{
-	errno_t rc;
+int fseek(FILE *stream, long offset, int whence)
+{
+	int rc;
 
 	if (stream->error)
@@ -814,5 +811,5 @@
 	stream->ungetc_chars = 0;
 
-	vfs_stat_t st;
+	struct stat st;
 	switch (whence) {
 	case SEEK_SET:
@@ -837,6 +834,10 @@
 }
 
-off64_t ftell64(FILE *stream)
-{
+long ftell(FILE *stream)
+{
+	/* The native position is too large for the C99-ish interface. */
+	if (stream->pos - stream->ungetc_chars > LONG_MAX)
+		return EOF;
+
 	if (stream->error)
 		return EOF;
@@ -851,20 +852,4 @@
 }
 
-int fseek(FILE *stream, long offset, int whence)
-{
-	return fseek64(stream, offset, whence);
-}
-
-long ftell(FILE *stream)
-{
-	off64_t off = ftell64(stream);
-
-	/* The native position is too large for the C99-ish interface. */
-	if (off > LONG_MAX)
-		return EOF;
-
-	return off;
-}
-
 void rewind(FILE *stream)
 {
@@ -889,5 +874,5 @@
 	
 	if ((stream->fd >= 0) && (stream->need_sync)) {
-		errno_t rc;
+		int rc;
 
 		/**
@@ -946,5 +931,5 @@
 }
 
-errno_t vfs_fhandle(FILE *stream, int *handle)
+int vfs_fhandle(FILE *stream, int *handle)
 {
 	if (stream->fd >= 0) {
Index: uspace/lib/c/generic/io/kio.c
===================================================================
--- uspace/lib/c/generic/io/kio.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/kio.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,7 +43,7 @@
 #include <io/printf_core.h>
 
-errno_t kio_write(const void *buf, size_t size, size_t *nwritten)
+int kio_write(const void *buf, size_t size, size_t *nwritten)
 {
-	errno_t rc = (errno_t) __SYSCALL3(SYS_KIO, KIO_WRITE, (sysarg_t) buf, size);
+	int rc = (int) __SYSCALL3(SYS_KIO, KIO_WRITE, (sysarg_t) buf, size);
 	
 	if (rc == EOK)
Index: uspace/lib/c/generic/io/klog.c
===================================================================
--- uspace/lib/c/generic/io/klog.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/klog.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,14 +42,18 @@
 #include <abi/log.h>
 
-errno_t klog_write(log_level_t lvl, const void *buf, size_t size)
+size_t klog_write(log_level_t lvl, const void *buf, size_t size)
 {
-	return (errno_t) __SYSCALL4(SYS_KLOG, KLOG_WRITE, (sysarg_t) buf,
+	ssize_t ret = (ssize_t) __SYSCALL4(SYS_KLOG, KLOG_WRITE, (sysarg_t) buf,
 	    size, lvl);
+	
+	if (ret >= 0)
+		return (size_t) ret;
+	
+	return 0;
 }
 
-errno_t klog_read(void *data, size_t size, size_t *nread)
+int klog_read(void *data, size_t size)
 {
-	return (errno_t) __SYSCALL5(SYS_KLOG, KLOG_READ, (uintptr_t) data,
-	    size, 0, (sysarg_t) nread);
+	return (int) __SYSCALL4(SYS_KLOG, KLOG_READ, (uintptr_t) data, size, 0);
 }
 
Index: uspace/lib/c/generic/io/log.c
===================================================================
--- uspace/lib/c/generic/io/log.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/log.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <io/log.h>
 #include <ipc/logger.h>
-#include <str.h>
 #include <ns.h>
 
@@ -75,5 +74,5 @@
  * @return Error code of the conversion or EOK on success.
  */
-static errno_t logger_message(async_sess_t *session, log_t log, log_level_t level, char *message)
+static int logger_message(async_sess_t *session, log_t log, log_level_t level, char *message)
 {
 	async_exch_t *exchange = async_exchange_begin(session);
@@ -89,6 +88,6 @@
 	aid_t reg_msg = async_send_2(exchange, LOGGER_WRITER_MESSAGE,
 	    log, level, NULL);
-	errno_t rc = async_data_write_start(exchange, message, str_size(message));
-	errno_t reg_msg_rc;
+	int rc = async_data_write_start(exchange, message, str_size(message));
+	sysarg_t reg_msg_rc;
 	async_wait_for(reg_msg, &reg_msg_rc);
 
@@ -128,5 +127,5 @@
  * @return Error code of the conversion or EOK on success.
  */
-errno_t log_level_from_str(const char *name, log_level_t *level_out)
+int log_level_from_str(const char *name, log_level_t *level_out)
 {
 	log_level_t level = LVL_FATAL;
@@ -161,5 +160,5 @@
  * @param prog_name Program name, will be printed as part of message
  */
-errno_t log_init(const char *prog_name)
+int log_init(const char *prog_name)
 {
 	log_prog_name = str_dup(prog_name);
@@ -199,6 +198,6 @@
 	aid_t reg_msg = async_send_1(exchange, LOGGER_WRITER_CREATE_LOG,
 	    parent, &answer);
-	errno_t rc = async_data_write_start(exchange, name, str_size(name));
-	errno_t reg_msg_rc;
+	int rc = async_data_write_start(exchange, name, str_size(name));
+	sysarg_t reg_msg_rc;
 	async_wait_for(reg_msg, &reg_msg_rc);
 
Index: uspace/lib/c/generic/io/logctl.c
===================================================================
--- uspace/lib/c/generic/io/logctl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/logctl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 static async_sess_t *logger_session = NULL;
 
-static errno_t start_logger_exchange(async_exch_t **exchange_out)
+static int start_logger_exchange(async_exch_t **exchange_out)
 {
 	assert(exchange_out != NULL);
@@ -78,12 +78,12 @@
  * @return Error code of the conversion or EOK on success.
  */
-errno_t logctl_set_default_level(log_level_t new_level)
+int logctl_set_default_level(log_level_t new_level)
 {
 	async_exch_t *exchange = NULL;
-	errno_t rc = start_logger_exchange(&exchange);
+	int rc = start_logger_exchange(&exchange);
 	if (rc != EOK)
 		return rc;
 
-	rc = (errno_t) async_req_1_0(exchange,
+	rc = (int) async_req_1_0(exchange,
 	    LOGGER_CONTROL_SET_DEFAULT_LEVEL, new_level);
 
@@ -101,8 +101,8 @@
  * @return Error code of the conversion or EOK on success.
  */
-errno_t logctl_set_log_level(const char *logname, log_level_t new_level)
+int logctl_set_log_level(const char *logname, log_level_t new_level)
 {
 	async_exch_t *exchange = NULL;
-	errno_t rc = start_logger_exchange(&exchange);
+	int rc = start_logger_exchange(&exchange);
 	if (rc != EOK)
 		return rc;
@@ -111,5 +111,5 @@
 	    new_level, NULL);
 	rc = async_data_write_start(exchange, logname, str_size(logname));
-	errno_t reg_msg_rc;
+	sysarg_t reg_msg_rc;
 	async_wait_for(reg_msg, &reg_msg_rc);
 
@@ -119,5 +119,5 @@
 		return rc;
 
-	return (errno_t) reg_msg_rc;
+	return (int) reg_msg_rc;
 }
 
@@ -126,8 +126,8 @@
  * @return Error code or EOK on success.
  */
-errno_t logctl_set_root(void)
+int logctl_set_root(void)
 {
 	async_exch_t *exchange = NULL;
-	errno_t rc = start_logger_exchange(&exchange);
+	int rc = start_logger_exchange(&exchange);
 	if (rc != EOK)
 		return rc;
@@ -137,5 +137,5 @@
 	rc = vfs_pass_handle(vfs_exch, vfs_root(), exchange);
 	vfs_exchange_end(vfs_exch);
-	errno_t reg_msg_rc;
+	sysarg_t reg_msg_rc;
 	async_wait_for(reg_msg, &reg_msg_rc);
 
@@ -145,5 +145,5 @@
 		return rc;
 
-	return (errno_t) reg_msg_rc;
+	return (int) reg_msg_rc;
 }
 
Index: uspace/lib/c/generic/io/output.c
===================================================================
--- uspace/lib/c/generic/io/output.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/output.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,8 +40,8 @@
 #include <io/output.h>
 
-errno_t output_yield(async_sess_t *sess)
+int output_yield(async_sess_t *sess)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, OUTPUT_YIELD);
+	int ret = async_req_0_0(exch, OUTPUT_YIELD);
 	async_exchange_end(exch);
 	
@@ -49,8 +49,8 @@
 }
 
-errno_t output_claim(async_sess_t *sess)
+int output_claim(async_sess_t *sess)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, OUTPUT_CLAIM);
+	int ret = async_req_0_0(exch, OUTPUT_CLAIM);
 	async_exchange_end(exch);
 	
@@ -58,8 +58,8 @@
 }
 
-errno_t output_get_dimensions(async_sess_t *sess, sysarg_t *maxx, sysarg_t *maxy)
+int output_get_dimensions(async_sess_t *sess, sysarg_t *maxx, sysarg_t *maxy)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_2(exch, OUTPUT_GET_DIMENSIONS, maxx, maxy);
+	int ret = async_req_0_2(exch, OUTPUT_GET_DIMENSIONS, maxx, maxy);
 	async_exchange_end(exch);
 	
@@ -67,10 +67,10 @@
 }
 
-errno_t output_get_caps(async_sess_t *sess, console_caps_t *ccaps)
+int output_get_caps(async_sess_t *sess, console_caps_t *ccaps)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
 	
 	sysarg_t rv;
-	errno_t ret = async_req_0_1(exch, OUTPUT_GET_CAPS, &rv);
+	int ret = async_req_0_1(exch, OUTPUT_GET_CAPS, &rv);
 	
 	async_exchange_end(exch);
@@ -89,10 +89,10 @@
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, OUTPUT_FRONTBUF_CREATE, &answer);
-	errno_t rc = async_share_out_start(exch, frontbuf, AS_AREA_READ
+	int rc = async_share_out_start(exch, frontbuf, AS_AREA_READ
 	    | AS_AREA_WRITE | AS_AREA_CACHEABLE);
 	
 	async_exchange_end(exch);
 	
-	errno_t ret;
+	sysarg_t ret;
 	async_wait_for(req, &ret);
 	
@@ -103,8 +103,8 @@
 }
 
-errno_t output_set_style(async_sess_t *sess, console_style_t style)
+int output_set_style(async_sess_t *sess, console_style_t style)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_1_0(exch, OUTPUT_SET_STYLE, style);
+	int ret = async_req_1_0(exch, OUTPUT_SET_STYLE, style);
 	async_exchange_end(exch);
 	
@@ -112,8 +112,8 @@
 }
 
-errno_t output_cursor_update(async_sess_t *sess, frontbuf_handle_t frontbuf)
+int output_cursor_update(async_sess_t *sess, frontbuf_handle_t frontbuf)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_1_0(exch, OUTPUT_CURSOR_UPDATE, frontbuf);
+	int ret = async_req_1_0(exch, OUTPUT_CURSOR_UPDATE, frontbuf);
 	async_exchange_end(exch);
 	
@@ -121,8 +121,8 @@
 }
 
-errno_t output_update(async_sess_t *sess, frontbuf_handle_t frontbuf)
+int output_update(async_sess_t *sess, frontbuf_handle_t frontbuf)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_1_0(exch, OUTPUT_UPDATE, frontbuf);
+	int ret = async_req_1_0(exch, OUTPUT_UPDATE, frontbuf);
 	async_exchange_end(exch);
 	
@@ -130,9 +130,9 @@
 }
 
-errno_t output_damage(async_sess_t *sess, frontbuf_handle_t frontbuf, sysarg_t col,
+int output_damage(async_sess_t *sess, frontbuf_handle_t frontbuf, sysarg_t col,
     sysarg_t row, sysarg_t cols, sysarg_t rows)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_5_0(exch, OUTPUT_DAMAGE, frontbuf, col, row,
+	int ret = async_req_5_0(exch, OUTPUT_DAMAGE, frontbuf, col, row,
 	    cols, rows);
 	async_exchange_end(exch);
Index: uspace/lib/c/generic/io/serial.c
===================================================================
--- uspace/lib/c/generic/io/serial.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/serial.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
  * @return EOK on success, ENOMEM if out of memory, EIO on I/O error
  */
-errno_t serial_open(async_sess_t *sess, serial_t **rserial)
+int serial_open(async_sess_t *sess, serial_t **rserial)
 {
 	serial_t *serial;
@@ -68,10 +68,10 @@
 
 /** Set serial port communication properties. */
-errno_t serial_set_comm_props(serial_t *serial, unsigned rate,
+int serial_set_comm_props(serial_t *serial, unsigned rate,
     serial_parity_t parity, unsigned datab, unsigned stopb)
 {
 	async_exch_t *exch = async_exchange_begin(serial->sess);
 
-	errno_t rc = async_req_4_0(exch, SERIAL_SET_COM_PROPS, rate, parity,
+	int rc = async_req_4_0(exch, SERIAL_SET_COM_PROPS, rate, parity,
 	    datab, stopb);
 
@@ -81,5 +81,5 @@
 
 /** Get serial port communication properties. */
-errno_t serial_get_comm_props(serial_t *serial, unsigned *rrate,
+int serial_get_comm_props(serial_t *serial, unsigned *rrate,
     serial_parity_t *rparity, unsigned *rdatab, unsigned *rstopb)
 {
@@ -87,5 +87,5 @@
 	sysarg_t rate, parity, datab, stopb;
 
-	errno_t rc = async_req_0_4(exch, SERIAL_GET_COM_PROPS, &rate, &parity,
+	int rc = async_req_0_4(exch, SERIAL_GET_COM_PROPS, &rate, &parity,
 	    &datab, &stopb);
 
Index: uspace/lib/c/generic/io/table.c
===================================================================
--- uspace/lib/c/generic/io/table.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/table.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 
 static table_column_t *table_column_first(table_t *);
@@ -52,5 +51,5 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t table_add_row(table_t *table, table_row_t **rrow)
+static int table_add_row(table_t *table, table_row_t **rrow)
 {
 	table_row_t *row;
@@ -75,5 +74,5 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t table_row_add_cell(table_row_t *row, table_cell_t **rcell)
+static int table_row_add_cell(table_row_t *row, table_cell_t **rcell)
 {
 	table_cell_t *cell;
@@ -100,5 +99,5 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t table_add_column(table_t *table, table_column_t **rcolumn)
+static int table_add_column(table_t *table, table_column_t **rcolumn)
 {
 	table_column_t *column;
@@ -122,7 +121,7 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t table_write_next_cell(table_t *table)
-{
-	errno_t rc;
+static int table_write_next_cell(table_t *table)
+{
+	int rc;
 
 	rc = table_row_add_cell(table->wrow, &table->wcell);
@@ -156,7 +155,7 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t table_write_next_row(table_t *table)
-{
-	errno_t rc;
+static int table_write_next_row(table_t *table)
+{
+	int rc;
 
 	rc = table_add_row(table, &table->wrow);
@@ -273,5 +272,5 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t table_cell_extend(table_cell_t *cell, const char *str, size_t len)
+static int table_cell_extend(table_cell_t *cell, const char *str, size_t len)
 {
 	char *cstr;
@@ -299,8 +298,8 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t table_create(table_t **rtable)
+int table_create(table_t **rtable)
 {
 	table_t *table;
-	errno_t rc;
+	int rc;
 
 	table = calloc(1, sizeof(table_t));
@@ -378,5 +377,5 @@
  * @return EOK on success, EIO on I/O error
  */
-errno_t table_print_out(table_t *table, FILE *f)
+int table_print_out(table_t *table, FILE *f)
 {
 	table_row_t *row;
@@ -475,9 +474,8 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t table_printf(table_t *table, const char *fmt, ...)
+int table_printf(table_t *table, const char *fmt, ...)
 {
 	va_list args;
-	errno_t rc;
-	int ret;
+	int rc;
 	char *str;
 	char *sp, *ep;
@@ -488,8 +486,8 @@
 
 	va_start(args, fmt);
-	ret = vasprintf(&str, fmt, args);
+	rc = vasprintf(&str, fmt, args);
 	va_end(args);
 
-	if (ret < 0) {
+	if (rc < 0) {
 		table->error = ENOMEM;
 		return table->error;
@@ -549,5 +547,5 @@
  * @return EOK if no error indicated, non-zero error code otherwise
  */
-errno_t table_get_error(table_t *table)
+int table_get_error(table_t *table)
 {
 	return table->error;
Index: uspace/lib/c/generic/io/visualizer.c
===================================================================
--- uspace/lib/c/generic/io/visualizer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/visualizer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,23 +39,23 @@
 #include <io/visualizer.h>
 
-errno_t visualizer_claim(async_sess_t *sess, sysarg_t notif_callback_id)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_1_0(exch, VISUALIZER_CLAIM, notif_callback_id);
-	async_exchange_end(exch);
-
-	return ret;
-}
-
-errno_t visualizer_yield(async_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, VISUALIZER_YIELD);
-	async_exchange_end(exch);
-
-	return ret;
-}
-
-errno_t visualizer_enumerate_modes(async_sess_t *sess, vslmode_t *mode, sysarg_t nth)
+int visualizer_claim(async_sess_t *sess, sysarg_t notif_callback_id)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	int ret = async_req_1_0(exch, VISUALIZER_CLAIM, notif_callback_id);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+int visualizer_yield(async_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	int ret = async_req_0_0(exch, VISUALIZER_YIELD);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+int visualizer_enumerate_modes(async_sess_t *sess, vslmode_t *mode, sysarg_t nth)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -64,21 +64,21 @@
 	aid_t req = async_send_1(exch, VISUALIZER_ENUMERATE_MODES, nth, &answer);
 
-	errno_t rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
-
-	async_exchange_end(exch);
-
-	errno_t ret;
-	async_wait_for(req, &ret);
-
-	if (rc != EOK) {
-		return rc;
-	} else if (ret != EOK) {
-		return ret;
-	} else {
-		return EOK;
-	}
-}
-
-errno_t visualizer_get_default_mode(async_sess_t *sess, vslmode_t *mode)
+	int rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
+
+	async_exchange_end(exch);
+
+	sysarg_t ret;
+	async_wait_for(req, &ret);
+
+	if (rc != EOK) {
+		return rc;
+	} else if (ret != EOK) {
+		return ret;
+	} else {
+		return EOK;
+	}
+}
+
+int visualizer_get_default_mode(async_sess_t *sess, vslmode_t *mode)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -87,21 +87,21 @@
 	aid_t req = async_send_0(exch, VISUALIZER_GET_DEFAULT_MODE, &answer);
 
-	errno_t rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
-
-	async_exchange_end(exch);
-
-	errno_t ret;
-	async_wait_for(req, &ret);
-
-	if (rc != EOK) {
-		return rc;
-	} else if (ret != EOK) {
-		return ret;
-	} else {
-		return EOK;
-	}
-}
-
-errno_t visualizer_get_current_mode(async_sess_t *sess, vslmode_t *mode)
+	int rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
+
+	async_exchange_end(exch);
+
+	sysarg_t ret;
+	async_wait_for(req, &ret);
+
+	if (rc != EOK) {
+		return rc;
+	} else if (ret != EOK) {
+		return ret;
+	} else {
+		return EOK;
+	}
+}
+
+int visualizer_get_current_mode(async_sess_t *sess, vslmode_t *mode)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -110,21 +110,21 @@
 	aid_t req = async_send_0(exch, VISUALIZER_GET_CURRENT_MODE, &answer);
 
-	errno_t rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
-
-	async_exchange_end(exch);
-
-	errno_t ret;
-	async_wait_for(req, &ret);
-
-	if (rc != EOK) {
-		return rc;
-	} else if (ret != EOK) {
-		return ret;
-	} else {
-		return EOK;
-	}
-}
-
-errno_t visualizer_get_mode(async_sess_t *sess, vslmode_t *mode, sysarg_t index)
+	int rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
+
+	async_exchange_end(exch);
+
+	sysarg_t ret;
+	async_wait_for(req, &ret);
+
+	if (rc != EOK) {
+		return rc;
+	} else if (ret != EOK) {
+		return ret;
+	} else {
+		return EOK;
+	}
+}
+
+int visualizer_get_mode(async_sess_t *sess, vslmode_t *mode, sysarg_t index)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -133,21 +133,21 @@
 	aid_t req = async_send_1(exch, VISUALIZER_GET_MODE, index, &answer);
 
-	errno_t rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
-
-	async_exchange_end(exch);
-
-	errno_t ret;
-	async_wait_for(req, &ret);
-
-	if (rc != EOK) {
-		return rc;
-	} else if (ret != EOK) {
-		return ret;
-	} else {
-		return EOK;
-	}
-}
-
-errno_t visualizer_set_mode(async_sess_t *sess, sysarg_t index, sysarg_t version, void *cells)
+	int rc = async_data_read_start(exch, mode, sizeof(vslmode_t));
+
+	async_exchange_end(exch);
+
+	sysarg_t ret;
+	async_wait_for(req, &ret);
+
+	if (rc != EOK) {
+		return rc;
+	} else if (ret != EOK) {
+		return ret;
+	} else {
+		return EOK;
+	}
+}
+
+int visualizer_set_mode(async_sess_t *sess, sysarg_t index, sysarg_t version, void *cells)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -156,21 +156,21 @@
 	aid_t req = async_send_2(exch, VISUALIZER_SET_MODE, index, version, &answer);
 
-	errno_t rc = async_share_out_start(exch, cells, AS_AREA_READ | AS_AREA_CACHEABLE);
-
-	async_exchange_end(exch);
-
-	errno_t ret;
-	async_wait_for(req, &ret);
-
-	if (rc != EOK) {
-		return rc;
-	} else if (ret != EOK) {
-		return ret;
-	} else {
-		return EOK;
-	}
-}
-
-errno_t visualizer_update_damaged_region(async_sess_t *sess,
+	int rc = async_share_out_start(exch, cells, AS_AREA_READ | AS_AREA_CACHEABLE);
+
+	async_exchange_end(exch);
+
+	sysarg_t ret;
+	async_wait_for(req, &ret);
+
+	if (rc != EOK) {
+		return rc;
+	} else if (ret != EOK) {
+		return ret;
+	} else {
+		return EOK;
+	}
+}
+
+int visualizer_update_damaged_region(async_sess_t *sess,
     sysarg_t x, sysarg_t y, sysarg_t width, sysarg_t height,
 	sysarg_t x_offset, sysarg_t y_offset)
@@ -182,5 +182,5 @@
 
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_5_0(exch, VISUALIZER_UPDATE_DAMAGED_REGION,
+	int ret = async_req_5_0(exch, VISUALIZER_UPDATE_DAMAGED_REGION,
 	    x, y, width, height, offsets);
 	async_exchange_end(exch);
@@ -189,17 +189,17 @@
 }
 
-errno_t visualizer_suspend(async_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, VISUALIZER_SUSPEND);
-	async_exchange_end(exch);
-
-	return ret;
-}
-
-errno_t visualizer_wakeup(async_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, VISUALIZER_WAKE_UP);
+int visualizer_suspend(async_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	int ret = async_req_0_0(exch, VISUALIZER_SUSPEND);
+	async_exchange_end(exch);
+
+	return ret;
+}
+
+int visualizer_wakeup(async_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	int ret = async_req_0_0(exch, VISUALIZER_WAKE_UP);
 	async_exchange_end(exch);
 
